// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.3.0
// - protoc             v3.21.7
// source: internal/module/agent_tracker/rpc/rpc.proto

package rpc

import (
	context "context"

	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

const (
	AgentTracker_GetConnectedAgentsByProjectIDs_FullMethodName = "/gitlab.agent.agent_tracker.rpc.AgentTracker/GetConnectedAgentsByProjectIDs"
	AgentTracker_GetConnectedAgentsByAgentIDs_FullMethodName   = "/gitlab.agent.agent_tracker.rpc.AgentTracker/GetConnectedAgentsByAgentIDs"
	AgentTracker_CountAgentsByAgentVersions_FullMethodName     = "/gitlab.agent.agent_tracker.rpc.AgentTracker/CountAgentsByAgentVersions"
)

// AgentTrackerClient is the client API for AgentTracker service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type AgentTrackerClient interface {
	GetConnectedAgentsByProjectIDs(ctx context.Context, in *GetConnectedAgentsByProjectIDsRequest, opts ...grpc.CallOption) (*GetConnectedAgentsByProjectIDsResponse, error)
	GetConnectedAgentsByAgentIDs(ctx context.Context, in *GetConnectedAgentsByAgentIDsRequest, opts ...grpc.CallOption) (*GetConnectedAgentsByAgentIDsResponse, error)
	CountAgentsByAgentVersions(ctx context.Context, in *CountAgentsByAgentVersionsRequest, opts ...grpc.CallOption) (*CountAgentsByAgentVersionsResponse, error)
}

type agentTrackerClient struct {
	cc grpc.ClientConnInterface
}

func NewAgentTrackerClient(cc grpc.ClientConnInterface) AgentTrackerClient {
	return &agentTrackerClient{cc}
}

func (c *agentTrackerClient) GetConnectedAgentsByProjectIDs(ctx context.Context, in *GetConnectedAgentsByProjectIDsRequest, opts ...grpc.CallOption) (*GetConnectedAgentsByProjectIDsResponse, error) {
	out := new(GetConnectedAgentsByProjectIDsResponse)
	err := c.cc.Invoke(ctx, AgentTracker_GetConnectedAgentsByProjectIDs_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *agentTrackerClient) GetConnectedAgentsByAgentIDs(ctx context.Context, in *GetConnectedAgentsByAgentIDsRequest, opts ...grpc.CallOption) (*GetConnectedAgentsByAgentIDsResponse, error) {
	out := new(GetConnectedAgentsByAgentIDsResponse)
	err := c.cc.Invoke(ctx, AgentTracker_GetConnectedAgentsByAgentIDs_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *agentTrackerClient) CountAgentsByAgentVersions(ctx context.Context, in *CountAgentsByAgentVersionsRequest, opts ...grpc.CallOption) (*CountAgentsByAgentVersionsResponse, error) {
	out := new(CountAgentsByAgentVersionsResponse)
	err := c.cc.Invoke(ctx, AgentTracker_CountAgentsByAgentVersions_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// AgentTrackerServer is the server API for AgentTracker service.
// All implementations must embed UnimplementedAgentTrackerServer
// for forward compatibility
type AgentTrackerServer interface {
	GetConnectedAgentsByProjectIDs(context.Context, *GetConnectedAgentsByProjectIDsRequest) (*GetConnectedAgentsByProjectIDsResponse, error)
	GetConnectedAgentsByAgentIDs(context.Context, *GetConnectedAgentsByAgentIDsRequest) (*GetConnectedAgentsByAgentIDsResponse, error)
	CountAgentsByAgentVersions(context.Context, *CountAgentsByAgentVersionsRequest) (*CountAgentsByAgentVersionsResponse, error)
	mustEmbedUnimplementedAgentTrackerServer()
}

// UnimplementedAgentTrackerServer must be embedded to have forward compatible implementations.
type UnimplementedAgentTrackerServer struct {
}

func (UnimplementedAgentTrackerServer) GetConnectedAgentsByProjectIDs(context.Context, *GetConnectedAgentsByProjectIDsRequest) (*GetConnectedAgentsByProjectIDsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetConnectedAgentsByProjectIDs not implemented")
}
func (UnimplementedAgentTrackerServer) GetConnectedAgentsByAgentIDs(context.Context, *GetConnectedAgentsByAgentIDsRequest) (*GetConnectedAgentsByAgentIDsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetConnectedAgentsByAgentIDs not implemented")
}
func (UnimplementedAgentTrackerServer) CountAgentsByAgentVersions(context.Context, *CountAgentsByAgentVersionsRequest) (*CountAgentsByAgentVersionsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CountAgentsByAgentVersions not implemented")
}
func (UnimplementedAgentTrackerServer) mustEmbedUnimplementedAgentTrackerServer() {}

// UnsafeAgentTrackerServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to AgentTrackerServer will
// result in compilation errors.
type UnsafeAgentTrackerServer interface {
	mustEmbedUnimplementedAgentTrackerServer()
}

func RegisterAgentTrackerServer(s grpc.ServiceRegistrar, srv AgentTrackerServer) {
	s.RegisterService(&AgentTracker_ServiceDesc, srv)
}

func _AgentTracker_GetConnectedAgentsByProjectIDs_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetConnectedAgentsByProjectIDsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentTrackerServer).GetConnectedAgentsByProjectIDs(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: AgentTracker_GetConnectedAgentsByProjectIDs_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentTrackerServer).GetConnectedAgentsByProjectIDs(ctx, req.(*GetConnectedAgentsByProjectIDsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _AgentTracker_GetConnectedAgentsByAgentIDs_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetConnectedAgentsByAgentIDsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentTrackerServer).GetConnectedAgentsByAgentIDs(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: AgentTracker_GetConnectedAgentsByAgentIDs_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentTrackerServer).GetConnectedAgentsByAgentIDs(ctx, req.(*GetConnectedAgentsByAgentIDsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _AgentTracker_CountAgentsByAgentVersions_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CountAgentsByAgentVersionsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentTrackerServer).CountAgentsByAgentVersions(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: AgentTracker_CountAgentsByAgentVersions_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentTrackerServer).CountAgentsByAgentVersions(ctx, req.(*CountAgentsByAgentVersionsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// AgentTracker_ServiceDesc is the grpc.ServiceDesc for AgentTracker service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var AgentTracker_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "gitlab.agent.agent_tracker.rpc.AgentTracker",
	HandlerType: (*AgentTrackerServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetConnectedAgentsByProjectIDs",
			Handler:    _AgentTracker_GetConnectedAgentsByProjectIDs_Handler,
		},
		{
			MethodName: "GetConnectedAgentsByAgentIDs",
			Handler:    _AgentTracker_GetConnectedAgentsByAgentIDs_Handler,
		},
		{
			MethodName: "CountAgentsByAgentVersions",
			Handler:    _AgentTracker_CountAgentsByAgentVersions_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "internal/module/agent_tracker/rpc/rpc.proto",
}
